From a55c39460fac5e6b4c96c2b2414eaf2928c43809 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Sep 02 2020 16:19:28 +0000
Subject: [PATCH 832/2232] Fix error on creating symlink that already exists


---

diff --git a/gen/build/src/lib.rs b/gen/build/src/lib.rs
index 4b81e1d..9498fe2 100644
--- a/gen/build/src/lib.rs
+++ b/gen/build/src/lib.rs
@@ -160,8 +160,7 @@ fn symlink_crate(prj: &Project, build: &mut Build) {
 
     let mut link = paths::include_dir(prj);
     link.push("CRATE");
-    let _ = fs::create_dir_all(&link);
-    let _ = paths::symlink_dir(manifest_dir, link.join(package_name));
+    let _ = out::symlink_dir(manifest_dir, link.join(package_name));
     build.include(link);
 }
 
@@ -175,12 +174,11 @@ fn generate_bridge(prj: &Project, build: &mut Build, rust_source_file: &Path) ->
     out::write(header_path, &generated.header)?;
 
     let ref link_path = paths::namespaced(&prj.out_dir, rel_path);
-    let _ = paths::symlink_or_copy(header_path, link_path);
+    let _ = out::symlink_file(header_path, link_path);
     if let TargetDir::Path(target_dir) = &prj.target_dir {
         let ref link_path = paths::namespaced(target_dir, rel_path);
-        let _ = fs::create_dir_all(link_path.parent().unwrap());
-        let _ = paths::symlink_or_copy(header_path, link_path);
-        let _ = paths::symlink_or_copy(header_path, link_path.with_appended_extension(".h"));
+        let _ = out::symlink_file(header_path, link_path);
+        let _ = out::symlink_file(header_path, link_path.with_appended_extension(".h"));
     }
 
     let ref rel_path_cc = rel_path.with_appended_extension(".cc");
diff --git a/gen/build/src/out.rs b/gen/build/src/out.rs
index 944c822..76e27f6 100644
--- a/gen/build/src/out.rs
+++ b/gen/build/src/out.rs
@@ -1,5 +1,6 @@
 use crate::error::{Error, Result};
 use crate::gen::fs;
+use crate::paths;
 use std::path::Path;
 
 pub(crate) fn write(path: impl AsRef<Path>, content: &[u8]) -> Result<()> {
@@ -26,3 +27,43 @@ pub(crate) fn write(path: impl AsRef<Path>, content: &[u8]) -> Result<()> {
         Err(err) => Err(Error::Fs(create_dir_error.unwrap_or(err))),
     }
 }
+
+pub(crate) fn symlink_file(src: impl AsRef<Path>, dst: impl AsRef<Path>) -> Result<()> {
+    let src = src.as_ref();
+    let dst = dst.as_ref();
+
+    let mut create_dir_error = None;
+    if dst.exists() {
+        let _ = fs::remove_file(dst).unwrap();
+    } else {
+        let parent = dst.parent().unwrap();
+        create_dir_error = fs::create_dir_all(parent).err();
+    }
+
+    match paths::symlink_or_copy(src, dst) {
+        // As long as symlink_or_copy succeeded, ignore any create_dir_all error.
+        Ok(()) => Ok(()),
+        // If create_dir_all and symlink_or_copy both failed, prefer the first error.
+        Err(err) => Err(Error::Fs(create_dir_error.unwrap_or(err))),
+    }
+}
+
+pub(crate) fn symlink_dir(src: impl AsRef<Path>, dst: impl AsRef<Path>) -> Result<()> {
+    let src = src.as_ref();
+    let dst = dst.as_ref();
+
+    let mut create_dir_error = None;
+    if dst.exists() {
+        let _ = fs::remove_file(dst).unwrap();
+    } else {
+        let parent = dst.parent().unwrap();
+        create_dir_error = fs::create_dir_all(parent).err();
+    }
+
+    match paths::symlink_dir(src, dst) {
+        // As long as symlink_dir succeeded, ignore any create_dir_all error.
+        Ok(()) => Ok(()),
+        // If create_dir_all and symlink_dir both failed, prefer the first error.
+        Err(err) => Err(Error::Fs(create_dir_error.unwrap_or(err))),
+    }
+}

